--[[ local Info about this version ]]--
local TITLE				=	"StoreMultiBuy";
local VERSION			=	0.6;
local INTERFACE			=	"2.0.8.1840";
local RELEASE_DATE		=	"08/21-2009";
local AUTHOR			=	"BuffyS, original by Zilvermoon";
local ADDON_LOADED		=	TITLE.." v"..VERSION;

--[[ local Storing variable ]]--
local MAXHEAP = nil;
local MAXHEAPCOUNT = nil;
local REMANING = nil;

local SMBDelay = 0.6; --1 second delay should be enough
local SMBElapsed = SMBDelay;
local SMBBuyCount = 0;
local SMBBuyItem = nil;
local SMBBuyMaxHeap = 0;

function SMB_OnLoad(this)
	this:RegisterEvent("VARIABLES_LOADED");
end

function SMB_OnEvent(event)
	if event == "VARIABLES_LOADED" then
		SMBMsg("AddOn loaded: |cffffffff"..ADDON_LOADED.."|r", 0.5, 0.7, 0.1);
		return;
	end
end

function SMBMsg(msg,red,green,blue)
	if ((red) and (green) and (b)) then
		DEFAULT_CHAT_FRAME:AddMessage(msg, red, green, blue);
	else
		DEFAULT_CHAT_FRAME:AddMessage(msg);
	end
end

local Org_StoreItemButton_OnClick;

function My_StoreItemButton_OnClick(this, key)
	local index = this:GetParent().index;

	if( ((key == "LBUTTON") or (key == "RBUTTON")) and IsShiftKeyDown() ) then
		local itemLink;
		if( STOREFRAME_CURRENT_TAB == "SELL" ) then
			itemLink = GetStoreSellItemLink(index);
			if ( ChatEdit_AddItemLink(itemLink) ) then
				return;
			end

			icon, name, price, moneyType, count, stock, maxHeap = GetStoreSellItemInfo(index);
			MAXHEAP = maxHeap;
--			if ( maxHeap <= 1 ) then
--				SendWarningMsg(STORE_ITEM_CANT_HEAP);
--				return;
--			end

--			local itemCount = 0; -- Debug feature
			local itemCount = math.floor(GetPlayerMoney("copper")/price) or 0;
			if (itemCount <= 0) then
				SendWarningMsg(CR_STR_BUYOUT_ALERT.." to buy "..name);
				return;
			end

			this.index = index;
			this.AskNumberFrameCallBack = function( button , Number )
				if (Number > MAXHEAP) then
					SMBBuyItem = index;
					SMBBuyCount = Number;
					SMBBuyMaxHeap = MAXHEAP
--					MAXHEAPCOUNT = math.floor(Number/MAXHEAP);
--					local REMANING = (Number-(MAXHEAPCOUNT*MAXHEAP));
--					for i=1, MAXHEAPCOUNT do
--						StoreBuyItem( this.index , REMANING );
--					end
--					StoreBuyItem( this.index , MAXHEAP );
				else
					StoreBuyItem( this.index , Number );
				end
			end

			OpenAskNumberFrame( 1, itemCount, this, "BOTTOMLEFT", "TOPRIGHT" );
			return;

		elseif( STOREFRAME_CURRENT_TAB == "BUYBACK" ) then
			itemLink = GetStoreBuyBackItemLink(index);
			ChatEdit_AddItemLink( itemLink );
		end
		return;
	elseif( key == "LBUTTON" and IsCtrlKeyDown() ) then
		local itemLink;
		if( STOREFRAME_CURRENT_TAB == "SELL" ) then
			itemLink = GetStoreSellItemLink(index);
		elseif( STOREFRAME_CURRENT_TAB == "BUYBACK" ) then
			itemLink = GetStoreBuyBackItemLink(index);
		end
		ItemPreviewFrame_SetItemLink( ItemPreviewFrame, itemLink );
		return;
	end

	if (key == "LBUTTON") then
		if (STOREFRAME_CURRENT_TAB == "SELL") then
			PickupStoreSellItem(index);
		elseif (STOREFRAME_CURRENT_TAB == "BUYBACK") then
			StoreBuyBackItem(index);
		end
	elseif (key == "RBUTTON") then
		if (STOREFRAME_CURRENT_TAB == "SELL") then
			StoreBuyItem(index);
		elseif (STOREFRAME_CURRENT_TAB == "BUYBACK") then
			StoreBuyBackItem(index);
		end
	end
end

function SMB_OnUpdate(this, elapsedTime)
		if (SMBBuyCount ~= 0) and GetItemQueueInfo(10) == nil then
			SMBElapsed = SMBElapsed - elapsedTime;
			if(SMBElapsed <= 0) then
				SMBElapsed = SMBDelay;
				if SMBBuyMaxHeap > SMBBuyCount then
					StoreBuyItem( SMBBuyItem , SMBBuyCount );
					SMBBuyCount = 0
				else
					StoreBuyItem( SMBBuyItem , SMBBuyMaxHeap );
					SMBBuyCount = SMBBuyCount - SMBBuyMaxHeap;
				end
			end
		end
end
Org_StoreItemButton_OnClick = StoreItemButton_OnClick;
StoreItemButton_OnClick = My_StoreItemButton_OnClick;
